__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain         PROTO   :DWORD,:DWORD,:DWORD,:DWORD
FillListView    PROTO   :DWORD
AddString       PROTO   :DWORD,:DWORD
DeleteString    PROTO   :DWORD

RegisterControls    PROTO   :DWORD,:DWORD
StaticExProc        PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ChevronProc         PROTO   :DWORD,:DWORD,:DWORD,:DWORD
DrawChev            PROTO   :DWORD


include \masm32\include\windows.inc
include ecl.inc

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\shell32.inc


includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\shell32.lib

include \masm32\macros\macros.asm

include \masm32\include\masm32.inc
includelib \masm32\lib\masm32.lib

.const  
MainWindowWidth     equ     600
MainWindowHeight    equ     400
MAXFILE             equ     256
.data
hInstance       HINSTANCE       ?
hMainWindow     HWND            ?

UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "Standard Window",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>

; +++ StaticEx related +++

UCSTR       StaticExClass,"STATICEX",0
hStx            HWND      ?
iecx            INITEXTRACONTROLS   <sizeof iecx,IEC_STATIC_CLASS>
acst        ACSTRUCT    <?,?,offset MainWindowName>
UCSTR       FaceName,"Lucida Caligraphy",0

; +++ List View related +++

UCSTR       ListViewClass,"SysListView32",0
hListView   HWND        ?
lvc         LV_COLUMN   <>
lvi         LV_ITEM     <>
UCSTR       szFileName,"FileName",0
UCSTR       szAttributes,"Attributes",0
TextBuffer  dw      256 dup(0)

; +++ Other +++

rect            RECT        <>
UCSTR       szDrive,"c:\*",0
            dw      MAXFILE dup(0)  
UCSTR       szAttr,"----",0
hFile       dd          ?
w32fd       WIN32_FIND_DATA     <>


.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  RegisterControls,hInstance,addr iecx
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPED\
                +WS_CLIPCHILDREN,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  GetClientRect,hWnd,addr rect
            sub     rect.bottom,22
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListViewClass,0,WS_VISIBLE+WS_CHILD+LVS_REPORT,\
                        0,rect.top,rect.right,rect.bottom,hWnd,0,hInstance,0
            mov     hListView,eax
            mov     lvc.imask,LVCF_TEXT+LVCF_WIDTH+LVCF_FMT
            mov     lvc.fmt,LVCFMT_LEFT
            mov     lvc.pszText,offset szFileName
            mov     eax,rect.right
            shr     eax,1
            mov     lvc.lx,eax
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,0,addr lvc
            shr     lvc.lx,1
            mov     lvc.pszText,offset szAttributes
            invoke  SendMessage,hListView,LVM_INSERTCOLUMN,1,addr lvc
            invoke  FillListView,hWnd
            add     rect.bottom,2
           invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticExClass,0,WS_VISIBLE or WS_CHILD or STXS_BOTTOM,\
                        0,rect.bottom,rect.right,20,hWnd,0,hInstance,0
            mov     hStx,eax 
            mov     acst.lpText,offset szDrive
            invoke  SendMessage,hStx,STXM_ADDCONTENT,0,addr acst 
            invoke  SendMessage,hListView,WM_GETFONT,0,0
            invoke  SendMessage,hStx,WM_SETFONT,eax,TRUE                                              
                                    
        .endif
    .elseif uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
        
    .elseif uMsg==WM_NOTIFY || uMsg==WM_NOTIFY2
        mov     edi,lParam
        .if     [edi.NM_STXHEIGHTCHANGED].hdr.code==STXN_HEIGHTCHANGED
            invoke  Beep,200,20
            invoke  GetClientRect,hWnd,addr rect
            mov     eax,[edi.NM_STXHEIGHTCHANGED].Height
            sub     rect.bottom,eax
            invoke  MoveWindow,hListView,0,0,rect.right,rect.bottom,TRUE
            
        .elseif [edi.NM_LISTVIEW].hdr.code==LVN_ITEMCHANGED
            .if     [edi.NM_LISTVIEW].iSubItem==0
                .if     [edi.NM_LISTVIEW].uNewState&LVIS_SELECTED  ; && != & 
                    mov     lvi.pszText,offset TextBuffer
                    mov     lvi.cchTextMax,sizeof TextBuffer
                    push    [edi.NM_LISTVIEW].iItem
                    pop     lvi.iItem
                    mov     lvi.imask,LVIF_TEXT or LVIF_PARAM
                    mov     lvi.iSubItem,0
                    invoke  SendMessage,hListView,LVM_GETITEM,0,addr lvi
                    mov     acst.lpText,offset TextBuffer
                    push    lvi.lParam
                    pop     acst.hIcon
                    ;mov     acst.hIcon,0
                    invoke  SendMessage,hStx,STXM_ADDCONTENT,0,addr acst
                .endif
            .endif                
        .endif            
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp                                                

FillListView    PROC    hWnd:DWORD

    local   shfi:SHFILEINFO
    local   SET_HIML:DWORD
    
    mov     SET_HIML,TRUE
    mov     lvi.imask,LVIF_TEXT+LVIF_IMAGE+LVIF_PARAM
    mov     lvi.pszText,offset w32fd.cFileName
    mov     lvi.iItem,0
    mov     lvi.iSubItem,0
    invoke  FindFirstFile,addr szDrive,addr w32fd
    or      eax,eax
    jz      no_files
    mov     hFile,eax
compares:
    cmp     w32fd.cFileName,"."
    je      find_next
    invoke  AddString,addr szDrive,addr w32fd.cFileName
    invoke  SHGetFileInfo,addr szDrive,0,addr shfi,sizeof shfi,SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_ICON
    .if     SET_HIML==TRUE
        invoke  SendMessage,hListView,LVM_SETIMAGELIST,LVSIL_SMALL,eax
        mov     SET_HIML,FALSE
    .endif
    mov     lvi.imask,LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
    mov     lvi.pszText,offset w32fd.cFileName
    push    shfi.iIcon
    pop     lvi.iImage
    push    shfi.hIcon
    pop     lvi.lParam
    mov lvi.iSubItem,0                                      
    invoke  SendMessage,hListView,LVM_INSERTITEM,0,addr lvi
    invoke  DeleteString,addr szDrive
    lea     edi,szAttr
    xor     ah,ah
    pushfd
    cld
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
    jz      no_dir
    mov     al,'d'
    jmp     next_1
no_dir:                           
    mov     al,'-'
next_1:
    stosw   
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_ARCHIVE
    jz      no_arc
    mov     al,'a'
    jmp     next_2
no_arc:
    mov     al,'-'
next_2:
    stosw
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_SYSTEM
    jz      no_sys
    mov     al,'s'
    jmp     next_3
no_sys:
    mov     al,'-'
next_3:
    stosw
    test    w32fd.dwFileAttributes,FILE_ATTRIBUTE_HIDDEN
    jz      no_hide
    mov     al,'h'
    jmp     end_attr
no_hide:
    mov     al,'-'
end_attr:
    stosw
    xor     eax,eax
    stosw
    popfd
    push    lvi.pszText
    mov     lvi.pszText,offset szAttr                 
    mov     lvi.imask,LVIF_TEXT
	mov lvi.iSubItem,1
    invoke  SendMessage,hListView,LVM_SETITEM,0,addr lvi
    inc     lvi.iItem
find_next:
    invoke  FindNextFile,hFile,addr w32fd
    cmp     eax,0;INVALID_HANDLE_VALUE
    je      no_files
    jmp     compares
no_files:           
    ret

FillListView    endp

AddString   PROC    lpDestination:DWORD,lpSource:DWORD


    push    esi
    push    edi
    pushfd
    mov     esi,lpDestination
    cld
    xor     ah,ah
align_loop:
    lodsw
    cmp     al,'\'
    jne     align_loop
    mov     edi,esi
    mov     esi,lpSource
copy_loop:
    lodsw
    cmp     al,0
    je      end_it
    stosw
    jmp     copy_loop
end_it:
    stosw
    popfd
    pop     edi
    pop     esi
    ret

AddString   endp                    

DeleteString    PROC    lpString:DWORD

    push    esi
    push    edi
    pushfd
    mov     esi,lpString
    cld
loop_1:
    lodsw
    cmp     al,'\'
    jnz     loop_1
    mov     edi,esi
    xor     ax,ax
    stosw
    popfd
    pop     edi
    pop     esi
    ret

DeleteString    endp

;###############################################################
;########     control    #######################################
;###############################################################

.const

.data
stxnsc  NM_STXHEIGHTCHANGED     <>
align 4
wcStaticEx  WNDCLASS    <CS_HREDRAW or CS_VREDRAW,offset StaticExProc,0,\
                        sizeof EXTRA,0,0,0,COLOR_WINDOW,0,\
                        offset StaticExClass>
; +++ Sub-Controls +++

UCSTR       ChevronClass,"CHEVRON",0
align 4
wcChevron   WNDCLASS    <CS_HREDRAW or CS_VREDRAW,offset ChevronProc,0,\
                        sizeof EXTRA,0,0,0,COLOR_WINDOW,0,offset ChevronClass>


.code
RegisterControls    PROC    hInst:HINSTANCE,dwControls:DWORD
   ; .if     dwControls&IEC_STATIC_CLASS
        push    hInst
        pop     wcStaticEx.hInstance
        sub     esp,4
        pop     wcChevron.hInstance
        invoke  RegisterClass,addr wcStaticEx
        invoke  RegisterClass,addr wcChevron
   ; .endif
    ret

RegisterControls    endp

StaticExProc    PROC    uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   BkMode:DWORD,hRgn:DWORD
    
    .if     uMsg==WM_CREATE
        invoke  LocalAlloc,LPTR,sizeof STEXSTRUCT
        mov     edi,eax
        push    hWnd
        pop     [edi.STEXSTRUCT].hWnd
        push    eax
        invoke  SetWindowLong,hWnd,EXTRA.hMem,eax
        pop     edi
        sub     esp,4
        mov     esi,lParam
        assume  esi:PTR CREATESTRUCT
        mov     ecx,sizeof CREATESTRUCT/4
        assume  edi:PTR STEXSTRUCT
        cld
loop_1:
        movsd
        dec     ecx
        jcxz    end_loop_1
        jmp     loop_1
end_loop_1:
        pop     edi
        mov     esi,lParam
        invoke  GetClientRect,[esi].hWndParent,addr [edi].WndRect
        test    [esi].style,STXS_BOTTOM
        jp      align_wnd_to_bottom
        test    [esi].style,STXS_TOP
        jz      proceed_01            
        cmp     [esi].y,0
        ja      align_to_top
        jmp     proceed_01
align_to_top:
        invoke  MoveWindow,hWnd,0,0,[edi].WndRect.right,[esi].ly,TRUE
        jmp     proceed_01
align_wnd_to_bottom:
        mov     eax,[esi].ly
        sub     [edi].WndRect.bottom,eax
        invoke  MoveWindow,hWnd,0,[edi].WndRect.bottom,[edi].WndRect.right,[esi].ly,TRUE
        jmp     proceed_01
proceed_01:
        .if     [esi].lpszName!=0
            push    [esi].lpszName
            pop     [edi].acstr.lpText
            mov     [edi].dwAction,ACT_TEXT
            invoke  SendMessage,hWnd,STXM_ADDCONTENT,0,addr [edi].acstr
        .endif            
            push    [esi].x
            pop     [edi].rect.left
            sub     esp,4
            pop     [edi].ChevStruct.cstr.x
            push    [esi].y
            pop     [edi].rect.top
            sub     esp,4
            test    [esi].style,STXS_BOTTOM
            jp      bottom_aligned
            pop     [edi].ChevStruct.cstr.y
            add     [edi].ChevStruct.cstr.y,2
            jmp     proceed_0
bottom_aligned:
            add     esp,4
            mov     eax,[esi].ly
            add     eax,[esi].y
            sub     eax,6
            mov     [edi].ChevStruct.cstr.y,eax
proceed_0:
            mov     eax,[esi].lx
            add     eax,[esi].x
            mov     [edi].rect.right,eax
            mov     eax,[esi].ly
            add     eax,[esi].y
            mov     [edi].rect.bottom,eax
            add     [edi].ChevStruct.cstr.x,2
            invoke  GetProcessHeap
            push    eax
            invoke  HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof CREATESTRUCTEX
            mov     [eax.CREATESTRUCTEX].hMem,eax
            push    hWnd
            pop     [eax.CREATESTRUCTEX].hWndRef
            pop     ebx
            mov     [eax.CREATESTRUCTEX].hHeap,ebx
            xor     [esi].style,WS_VISIBLE
            invoke  CreateWindowEx,NULL,addr ChevronClass,0,[esi].style,\
                         [edi].ChevStruct.cstr.x,[edi].ChevStruct.cstr.y,7,4,\
                         [edi].cstr.hWndParent,0,[esi].hInstance,eax
            mov     [edi].ChevStruct.hCh,eax

            assume  esi:NOTHING
            assume  edi:NOTHING
                                                      
    .elseif uMsg==STXM_ADDCONTENT
        mov     edi,lParam
        assume  edi:PTR ACSTRUCT
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        mov eax,[esi].dwAction
        .if [edi].hIcon != 0
            or  eax,ACT_ICON
            push    [edi].hIcon
            pop     [esi].acstr.hIcon
        .else
            .if [edi].hBitmap!=0
                or      eax,ACT_BITMAP
                push    [edi].hBitmap
                pop     [esi].acstr.hBitmap
            .endif                
        .endif
        .if [edi].lpText!=0
            or  eax,ACT_TEXT
            push    [edi].lpText
            pop     [esi].acstr.lpText
        .endif
        or      eax,ACT_SHOW
        mov     [esi].dwAction,eax
        invoke  ShowWindow,[esi].ChevStruct.hCh,SW_HIDE
        invoke  ShowWindow,hWnd,SW_SHOW
        invoke  InvalidateRect,hWnd,0,1
        invoke  SetTimer,hWnd,0100,2000,0
        
        assume  esi:NOTHING
        assume  edi:NOTHING
    .elseif uMsg==WM_PAINT

        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
       
        lea     edi,[esi].ps
        assume  edi:PTR PAINTSTRUCT
        invoke  GetBkMode,[edi].hdc
        mov     BkMode,eax
        invoke  BeginPaint,hWnd,edi
        invoke  CreateCompatibleDC,[edi].hdc
        mov     [esi].hMemDC,eax
        test    [esi].dwAction,ACT_ICON
        jz      no_icon
        invoke  DrawIconEx,[edi].hdc,[edi].rcPaint.left,[edi].rcPaint.top,[esi].acstr.hIcon,\
                    20,20,0,0,DI_NORMAL
        add     [edi].rcPaint.left,32
        jmp     test_4_text
no_icon:        
        test    [esi].dwAction,ACT_BITMAP
        jz      test_4_text
        invoke  SelectObject,[esi].hMemDC,[esi].acstr.hBitmap
        invoke  DeleteObject,eax
        invoke  GetBitmapDimensionEx,[esi].acstr.hBitmap,addr [esi]._size
        invoke  StretchBlt,[edi].hdc,[edi].rcPaint.top,[edi].rcPaint.top,20,20,\
                    [esi].hMemDC,0,0,[esi]._size.x,[esi]._size.y,SRCCOPY
        add     [edi].rcPaint.left,32                        
test_4_text:
        test    [esi].dwAction,DEF_FONT
        jz      do_text
        invoke  SelectObject,[edi].hdc,[esi].hFont
        invoke  DeleteObject,eax
        test    [esi].dwAction,ACT_TEXT
        jz      no_text
do_text:        
        invoke  SetBkMode,[edi].hdc,TRANSPARENT
        invoke  DrawText,[edi].hdc,[esi].acstr.lpText,-1,addr [edi].rcPaint,DT_LEFT
no_text:
        invoke  DeleteDC,[esi].hMemDC
        invoke  SetBkMode,[edi].hdc,BkMode
        invoke  EndPaint,hWnd,edi

        assume  edi:NOTHING      
        assume  esi:NOTHING 
        
    .elseif uMsg==WM_TIMER
        .if     wParam==0100
            invoke  GetWindowLong,hWnd,EXTRA.hMem
            mov     esi,eax
            assume  esi:PTR STEXSTRUCT
            xor     [esi].dwAction,ACT_SHOW
            invoke  ShowWindow,hWnd,SW_HIDE
            invoke  ShowWindow,[esi].ChevStruct.hCh,SW_SHOW
            invoke  InvalidateRect,[esi].ChevStruct.hCh,0,TRUE
            mov     stxnsc.Height,8
            or      stxnsc.hdr.code,STXN_HEIGHTCHANGED
            invoke  GetWindow,hWnd,GW_OWNER
            invoke  SendMessage,[esi].cstr.hWndParent,WM_NOTIFY,0,addr stxnsc
            invoke  KillTimer,hWnd,0100            
        .endif        
        ASSUME  esi:NOTHING
    .elseif uMsg==WM_SETFONT
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     edi,eax
        push    wParam
        pop     [edi.STEXSTRUCT].hFont
        or      [edi.STEXSTRUCT].dwAction,DEF_FONT
        .if     lParam==TRUE
            invoke  InvalidateRect,hWnd,addr [edi.STEXSTRUCT].rect,TRUE
        .endif
                    
   .elseif uMsg==WM_DESTROY
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        invoke  LocalFree,eax
               
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret       
    .endif
    mov     eax,0
    ret        
        
StaticExProc    endp

ChevronProc     PROC   uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    
    .if     uMsg==WM_CREATE

        mov     esi,lParam
        mov     esi,[esi.CREATESTRUCTEX].cstr.lpCreateParams
        assume  esi:PTR CREATESTRUCTEX
        invoke  GetWindowLong,[esi].hWndRef,EXTRA.hMem
        mov     edi,eax
        assume  edi:PTR STEXSTRUCT
        invoke  SetWindowLong,hWnd,EXTRA.hMem,edi
        push    edi
        mov     ecx,sizeof CREATESTRUCT/4
        cld
copy_loop:
        movsd
        dec     ecx
        jcxz    end_copy_loop
        jmp     copy_loop
end_copy_loop:     
        pop     edi
        mov     esi,lParam
        mov     esi,[esi.CREATESTRUCT].lpCreateParams
        assume  esi:PTR CREATESTRUCTEX
        push    [esi].cstr.x        
        pop     [edi].ChevStruct.rect.left
        mov     eax,[esi].cstr.lx
        add     eax,[esi].cstr.x
        mov     [edi].ChevStruct.rect.right,eax
        push    [esi].cstr.y
        pop     [edi].ChevStruct.rect.top
        mov     eax,[esi].cstr.ly
        add     eax,[esi].cstr.y
        mov     [edi].ChevStruct.rect.bottom,eax
        test    [esi].cstr.style,STXS_BOTTOM
        jp      bottom_aligned
        invoke  CreatePolygonRgn,addr [edi].ChevStruct.chPtsTop,3,ALTERNATE
        jmp     proceed_1
bottom_aligned:        
        invoke  CreatePolygonRgn,addr [edi].ChevStruct.chPtsBottom,3,ALTERNATE
proceed_1:        
        mov     [edi].ChevStruct.chRgn,eax
        invoke  GetDC,hWnd
        mov     [edi].hDC,eax
        invoke  SelectObject,[edi].hDC,[edi].ChevStruct.chRgn
        invoke  DeleteObject,eax
        invoke  ReleaseDC,hWnd,[edi].hDC
        invoke  HeapFree,[esi].hHeap,0,[esi].hMem

        ASSUME  esi:NOTHING
        ASSUME  edi:NOTHING
        
    .elseif uMsg==WM_PAINT

        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        lea     edi,[esi].ps
        invoke  BeginPaint,hWnd,edi
        test    [esi].cstr.style,STXS_BOTTOM
        jp      bottom_aligned_2 
        invoke  DrawChev,TOP_ALIGN
        jmp     end_it        
bottom_aligned_2:        
        invoke  DrawChev,BOTTOM_ALIGN
end_it:        
        invoke  EndPaint,hWnd,edi

        assume  esi:NOTHING
        assume  edi:NOTHING
        
    .elseif uMsg==WM_MOUSEMOVE
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        invoke  ShowWindow,[esi].hWnd,SW_SHOW
        invoke  ShowWindow,hWnd,SW_HIDE
        invoke  InvalidateRect,[esi].hWnd,addr [esi].rect,TRUE
        mov     stxnsc.hdr.code,STXN_HEIGHTCHANGED
        push    [esi].cstr.ly
        pop     stxnsc.Height
        invoke  GetWindow,hWnd,GW_OWNER
        invoke  SendMessage,eax,WM_NOTIFY,0,addr stxnsc
        
        assume  esi:NOTHING
        
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax        
    ret
    
ChevronProc     endp

DrawChev    PROC    DrawHow:DWORD

    assume  edi:PTR PAINTSTRUCT
    
    .if     DrawHow==TOP_ALIGN
        invoke  MoveToEx,[edi].hdc,0,0,0
        invoke  CreatePen,PS_SOLID,1,0ffffffh
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,6,0
        invoke  LineTo,[edi].hdc,3,3       
        invoke  CreatePen,PS_SOLID,1,0
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,0,0 
     .elseif DrawHow==BOTTOM_ALIGN
        invoke  MoveToEx,[edi].hdc,3,0,0
        invoke  CreatePen,PS_SOLID,1,0ffffffh
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,6,3
        invoke  LineTo,[edi].hdc,0,3
        invoke  CreatePen,PS_SOLID,1,0
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,3,0        
    .endif
    ret

DrawChev    endp

end     start